﻿using System;
using JsonApiServer.Controllers;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FunctionalTests
{
   [TestClass]
   public class AuthorizeControllerTest
   {
      [TestMethod]
      public void Authorize_succeeded()
      {
         var controller = new AuthorizeController();
         var request = new AuthorizeController.AuthorizeRequest
         {
            ReaderId = "8",
            DocId = Guid.NewGuid().ToString(),
            DocCode = "0000-0000-0000-00000000",
            DocExternalKey = "ValidExternalKey"
         };

         var result = controller.Authorize(request);

         Assert.IsNotNull(result);
         Assert.IsTrue(result.Succeed);
         Assert.IsNull(result.AccessPolicy);
      }

      [TestMethod]
      public void Authorize_failed()
      {
         var controller = new AuthorizeController();
         var request = new AuthorizeController.AuthorizeRequest
         {
            ReaderId = "8",
            DocId = Guid.NewGuid().ToString(),
            DocCode = "0000-0000-0000-00000000",
            DocExternalKey = "InvalidExternalKey"
         };

         var result = controller.Authorize(request);

         Assert.IsNotNull(result);
         Assert.IsFalse(result.Succeed);
         Assert.IsNull(result.AccessPolicy);
      }
   }
}
