﻿using System;
using System.Net.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Filters;
using System.Web.Script.Serialization;

namespace JsonApiServer.Attributes
{
    public class BindJson : ActionFilterAttribute
    {
        private readonly string _queryStringKey;
        private readonly Type _type;

        public BindJson(Type type, string queryStringKey)
        {
            _type = type;
            _queryStringKey = queryStringKey;
        }

        public override void OnActionExecuting(HttpActionContext actionContext)
        {
            string json = actionContext.Request.RequestUri.ParseQueryString()[_queryStringKey];
            if (string.IsNullOrEmpty(json))
            {
                actionContext.ActionArguments[_queryStringKey] = null;
            }
            else
            {
                var serializer = new JavaScriptSerializer();
                actionContext.ActionArguments[_queryStringKey] = serializer.Deserialize(json, _type);
            }
        }
    }
}